Subject: Re: [PATCH v2 1/3] worktree: remove "the_repository" from is_current_worktree()

From: Shreyansh Paliwal <[email-masked]>
Date: Mon, 23 Mar 2026 15:11:38 +0530

> On 16/03/2026 16:22, Phillip Wood wrote:
> >
> >> I have been staring at this code for longer than I want to admit, and I
> >> still haven't convinced myself that this is not a change in behaviour.
> >> I think what I'm wondering about is what `is_current_worktree()` is
> >> actually intended to do. In other words, what _do_ we consider to be
> >> "current"?
> >
> > There was some discussion about that in [1] where reviewers were
> > surprised that we needed to call is_current_worktree() here. This change
> > is consistent with the rest of the patch but you're right that it is a
> > change in behavior as at the moment the "current" worktree is set by the
> > worktree that the process was started in. In practice we only ever have
> > a single struct repository instance per process so there is no practical
> > change in behavior here. At the moment, if you visit a set of submodules
> > from the superproject by forking one process per submodule each
> > submodule worktree is considered "current", but if you visit them by
> > spinning up some threads in the current process they are not considered
> > "current". That seems to me to be inconsistent as the process started by
> > the user is in the superproject in both cases.
>
> To add another example get_worktree_ref_store() checks `wt->is_current`
> to see if it should use the ref store in `wt->repo` or create a new
> store. That means that if we use `the_repository` to define the current
> worktree we'll end up opening a copy of the ref store in `wt->repo` when
> `repo != the_repository` and `wt->path` matches `wt->repo->worktree`
> when we could be using the ref store that's already open. It is a bit
> like the bug fixed by 1339cb3c47a (worktree: don't store main worktree
> twice, 2024-06-06) but for multiple repositories.
>
> I'll re-roll with a bit more description in the commit message but I'm
> going to be off the list for most of the rest of this week so it will
> probably be next week before I post a new version.
>
> Thanks
>
> Phillip
>
> > The "is_current" field was added in [1] without any discussion in the
> > commit message. It seems to have been added to stop the same branch
> > being checked out in multiple worktrees [2].
> >
> > Thanks
> >
> > Phillip
> >
> > [1] 750e8a60d69 (worktree.c: mark current worktree, 2016-04-22)
> > [2] https://lore.kernel.org/git/
> > CAJZYdzhG8h3s=Ep1fuGbam1cWhYkv0tW6tQ7pBGGj+fj6=[email-masked]/
> >
> >
> >> I would consider the worktree "current" that the Git process
> >> has been invoked in. So if I pass a repo other than `the_repository`, or
> >> if I pass a worktree that is not the one that Git has been started in,
> >> then I would expect the function to return `false`. With that naive
> >> assumption your change would be breaking the existing logic.
> >>
> >> But I have no idea whether my assumption is correct or not, as
> >> there is not really any documentation of what the function or of the
> >> `struct worktree::is_current` field. And having a look at a couple of
> >> callers doesn't really make me all the wiser.
> >>
> >> It would be great if you could shine some light on this and then also
> >> add a bit of documentation to either the function, the field, or both :)
> >>
> >> Thanks!
> >>
> >> Patrick
> >>
> >

Hi Phillip,

This may be slightly out of scope for this series. My understanding so far
has been that originally wt == NULL is used to represent the 'current worktree',
which eventually meant following the process-wide state (the_repository).
With the ongoing multi-repository work, the meaning is being changed to be
interpreted as 'the worktree associated with the repository that we are working in'.
However, in path.c there are some callers of repo_git_pathv() passing wt as 'NULL',
I know that there is not involvement of the_repository state but it would be create
less confusion if the semantics of worktrees are same everywhere. So if we replace
those NULL callers with the current worktree and update the checks of (!wt) to
(is_current_worktree(wt)), some tests are failing mostly related to refs of linked
worktrees, and I think the error is originating from this,

        if (!wt)
                adjust_git_path(repo, buf, gitdir_len);

So I am a bit confused to whether wt being NULL here could mean something else
behaviour wise ?

Best,
Shreyansh